Package org.eclipse.ecf.remoteservice.client

# Interface IRemoteCallParameterSerializer

All Known Implementing Classes:
  `AbstractParameterSerializer`, `StringParameterSerializer`

public interface IRemoteCallParameterSerializer
Call parameter serializer. Represents the serializer for remote call parameters.

Since:
  4.0

## Method Summary

Modifier and Type
Method
Description
`IRemoteCallParameter[]`
`serializeParameter(String endpoint, IRemoteCall call, IRemoteCallable callable, IRemoteCallParameter[] currentParameters, Object[] paramToSerialize)`
Serializes all remote call parameters of this call.
`IRemoteCallParameter`
`serializeParameter(String endpoint, IRemoteCall call, IRemoteCallable callable, IRemoteCallParameter paramDefault, Object paramToSerialize)`
Serialize a remote call parameter.

## Method Details

### serializeParameter

IRemoteCallParameter serializeParameter(String endpoint, IRemoteCall call, IRemoteCallable callable, IRemoteCallParameter paramDefault, Object paramToSerialize) throws NotSerializableException
Serialize a remote call parameter.

Parameters:
  `endpoint` - the endpoint. Should not be `null`.
  `call` - the call associated with the parameter to serialize. Will not be `null`.
  `callable` - the callable associated with the parameter to serialize. Will not be `null`.
  `paramDefault` - the default value (from the callable), for the parameter to serialize.
  `paramToSerialize` - the actual parameter value to serialize.
Returns:
  IRemoteCallParameter the serialized parameter...with appropriate name and serialized value.
Throws:
  `NotSerializableException` - if parameter cannot be serialized.

### serializeParameter

IRemoteCallParameter[] serializeParameter(String endpoint, IRemoteCall call, IRemoteCallable callable, IRemoteCallParameter[] currentParameters, Object[] paramToSerialize) throws NotSerializableException
Serializes all remote call parameters of this call. This method is invoked after `IRemoteCallParameter` `serializeParameter(String, IRemoteCall, IRemoteCallable, IRemoteCallParameter, Object)` and allows to override its results (read override IRemoteCallParameters).

Parameters:
  `endpoint` - the endpoint. Should not be `null`.
  `call` - the call associated with the parameter to serialize. Will not be `null`.
  `callable` - the callable associated with the parameter to serialize. Will not be `null`.
  `currentParameters` - the list of current parameters (from the callable) that would be send
  `paramToSerialize` - all parameters to serialize.
Returns:
  List the serialized parameters...with appropriate name and serialized value.
Throws:
  `NotSerializableException` - if a parameter cannot be serialized.
Since:
  8.0
See Also:
  - "https://bugs.eclipse.org/408034"
Restriction:
  This method is not intended to be referenced by clients.